"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_ioc_1 = require("./typescript-ioc");
class ContainerConfig {
    static addSource(patterns, baseDir) {
        const requireGlob = require('require-glob');
        baseDir = baseDir || process.cwd();
        requireGlob.sync(patterns, {
            cwd: baseDir
        });
    }
    static configure(...configurations) {
        configurations.forEach(config => {
            const bind = typescript_ioc_1.Container.bind(config.bind);
            if (bind) {
                if (config.to) {
                    bind.to(config.to);
                }
                else if (config.provider) {
                    bind.provider(config.provider);
                }
                if (config.scope) {
                    bind.scope(config.scope);
                }
                if (config.withParams) {
                    bind.withParams(config.withParams);
                }
            }
        });
    }
}
exports.ContainerConfig = ContainerConfig;
//# sourceMappingURL=container-config.js.map